For AI agents: a documentation index is available at the root level at /llms.txt and /llms-full.txt. Append /llms.txt to any URL for a page-level index, or .md for the markdown version of any page.
      • AstroFully-managed data operations, powered by Apache Airflow.
      • Astro Private CloudRun Airflow-as-a-service in your environment.
      • Professional ServicesExpert Airflow services for your enterprise's success.
    • Tools
      • Cosmos
      • Orbiter
      • CLI
      • AI SDK
      • Agents
      • Blueprint
      • UpdatesThe State of Airflow 2026See the insights from over 5,800 data practitioners in the full report. Download Now ➔
  • Customers
  • Docs
    • Insights
      • Blog
      • Webinars
      • Resource Library
      • Events
    • Education
      • Academy
      • What is Airflow?
  • Pricing
Get Started Free
  • Astro API v1
    • Overview
    • Get started
    • Versioning and support
    • Migrate to v1
    • Deploy with the API
  • API Reference
      • POSTCreate a custom role
      • DELDelete a custom role
      • GETGet a custom role
      • GETGet role templates
      • GETList roles
      • POSTUpdate custom role
    • Changelog
    • Book Office Hours

Product

  • Platform Overview
  • Astro
  • Astro Observe
  • Astro Private Cloud
  • Security & Trust
  • Pricing

Tools & Services

  • Cosmos
  • Docs
  • Professional Services
  • Product Updates

Use Cases

  • AI Ops
  • Data Observability
  • ETL/ELT
  • ML Ops
  • Operational Analytics
  • All Use Cases

Industries

  • Financial Services
  • Gaming
  • Retail
  • Manufacturing
  • Healthcare
  • All Industries

Resources

  • Academy
  • eBooks & Guides
  • Blog
  • Webinars
  • Events
  • The Data Flowcast Podcast
  • All Resources

Airflow

  • What is Airflow
  • Airflow on Astro
  • Airflow 3.0
  • Airflow Upgrades
  • Airflow Use Cases
  • Airflow 2.x End of Life

Company

  • Our Story
  • Customers
  • Newsroom
  • Careers
  • Contact

Support

  • Knowledge Base
  • Status
  • Contact Support
GitHubYouTubeLinkedInx
  • Legal
  • Privacy
  • Terms of Service
  • Consent Preferences

  • Do Not Sell or Share My Personal information
  • Limit the Use Of My Sensitive Personal Information

Apache Airflow®, Airflow, and the Airflow logo are trademarks of the Apache Software Foundation. Copyright © Astronomer 2026. All rights reserved.

LogoLogo
API ReferenceRole

List roles

GET
https://api.astronomer.io/v1/organizations/:organizationId/roles
GET
/v1/organizations/:organizationId/roles
$curl https://api.astronomer.io/v1/organizations/organizationId/roles \
> -H "Authorization: Bearer <token>"
1{
2 "limit": 1,
3 "offset": 1,
4 "roles": [
5 {
6 "createdAt": "2022-11-22T04:37:12Z",
7 "createdBy": {
8 "id": "clm8qv74h000008mlf08scq7k",
9 "apiTokenName": "my-token",
10 "avatarUrl": "https://avatar.url",
11 "fullName": "Jane Doe",
12 "subjectType": "USER",
13 "username": "user1@company.com"
14 },
15 "id": "cluc9tapx000901qn2xrgqdmn",
16 "name": "Deployment_Viewer",
17 "restrictedWorkspaceIds": [
18 "cldbvzoi20182g8odxt8ehi5i"
19 ],
20 "scopeType": "DEPLOYMENT",
21 "updatedAt": "2022-11-22T04:37:12Z",
22 "updatedBy": {
23 "id": "clm8qv74h000008mlf08scq7k",
24 "apiTokenName": "my-token",
25 "avatarUrl": "https://avatar.url",
26 "fullName": "Jane Doe",
27 "subjectType": "USER",
28 "username": "user1@company.com"
29 },
30 "description": "Subject can only view deployments."
31 }
32 ],
33 "totalCount": 1,
34 "defaultRoles": [
35 {
36 "name": "Deployment_Viewer",
37 "permissions": [
38 "deployment.get"
39 ],
40 "scopeType": "DEPLOYMENT",
41 "description": "Subject can only view deployments."
42 }
43 ]
44}
List available user roles in an Organization.
Was this page helpful?
Previous

Update custom role

Next
Built with

Authentication

AuthorizationBearer

Bearer authentication of the form Bearer <token>, where token is your auth token.

Path parameters

organizationIdstringRequired
The Organization's ID.

Query parameters

includeDefaultRolesbooleanOptional
Whether to include default Astro roles in the returned list.
scopeTypeslist of enumsOptional
Filter the list of roles based on the scope of each role.
Allowed values:
offsetintegerOptional>=0Defaults to 0
Offset for pagination.
limitintegerOptional>=0Defaults to 20
Limit for pagination.
sortslist of enumsOptional

Sorting criteria, each criterion should conform to format ‘fieldName:asc’ or ‘fieldName:desc’.

Response

OK
limitinteger
The number of custom roles returned.
offsetinteger
The offset of the custom roles.
roleslist of objects
The list of custom roles.
totalCountinteger
The total number of custom roles.
defaultRoleslist of objects
The list of default roles.

Errors

400
Bad Request Error
401
Unauthorized Error
403
Forbidden Error
404
Not Found Error
500
Internal Server Error